function [beta,vcv,ttest,rsq,ftest,vrez,rez]=justols(y,x,lag);
%[beta,vcv,ttest,rsq]=justols(y,x);
%ols coef. vcv variance covariance matrix. ttest that beta=0
%rsq R-squared. 

beta = x\y;
%beta2 = inv(x'*x)*x'*y;


rez = y-x*beta;

if nargin>2;
    vrez = nwest(x.*repmat(rez,1,size(x,2)),lag);
    vcv =  inv(x'*x)*vrez*inv(x'*x);

else
    vrez = var(rez);
    vcv = vrez*inv(x'*x);

end

ttest = beta./sqrt(diag(vcv));

rsq = 1 - sum(rez.^2)./sum((y-mean(y)).^2); 

%    'F-test'
if size(x,2) > 1;
ftest = (size(rez,1)-size(x,2)+1)*((var(y)-var(rez))/var(rez))/(size(x,2)-1);
end;


function [hcov] = nwest(res,lag)
%[hcov] = nwest(res,lag)
%------------------------------------------------------------------------
% sub-function that computes Newey-West HAC covariances
%------------------------------------------------------------------------

obs = size(res,1);
hcov = res'*res; 
for s=1:lag
   hcov = hcov +  (1-s/(lag+1))*(res(s+1:obs,:)'*res(1:obs-s,:)) +(1-s/(lag+1))*(res(1:obs-s,:)'*res(s+1:obs,:)) ;
end
%Hamilton's equation 10.5.21