
%main.m Program to estimated VARs and identify shocks. 


% DATA Section
load  raqcimp.txt; poil=raqcimp(1+24:end,3);
load  cpiaucsa.txt; cpi=cpiaucsa(1+24:end,3);
rpoil=log(poil./cpi);  
rpoil=rpoil(3:end,1);   		
time=1973+2/4:1/4:2007+4/4;
drpoil = zeros(length(time),1);
rpoillev= zeros(length(time),1);

for i=1:length(time)
   drpoil(i,1)=(rpoil(3*(i-1)+4)-rpoil(3*(i-1)+1))*100;
   rpoillev(i,1) = rpoil(3*(i-1)+4);
end;

% FRED: Percent change in real GDP: 1973.II-2007.IV
load  fredgdp.txt; dy=diff(log(fredgdp(:,3)))*100;
ylev = 100*log(fredgdp(2:end,3));
ylevwlag = 100*log(fredgdp(1:end,3));
dp = drpoil;
fcastdata =[dp dy];
fcastdatalevwithzero = [100*[rpoil(1); rpoillev] ylevwlag];
dppos = (dp>0).*dp;
fcastdatapos = [dppos fcastdata(:,2)];
 
bigp = fcastdatalevwithzero(:,1);

for zx = 2:length(bigp);
    bigp(zx) = max( fcastdatalevwithzero(max(1,zx-4):zx-1,1));
end;
netchange = fcastdatalevwithzero(2:end,1) - bigp(2:end);
netchangecensored = (netchange>0).*netchange;


% Pseudo-true linear symmetric VAR model and pseudo-true IRFs
p=6; h=18; 

% no need for changes below here. 

fflocation = 1;
sortprog = inline('cumsum(x)','x');

trendval = [];
vardetrend = [];

%STEP 2: Estimate VARs
nstep = 21;
nlag = 6;
hascon = 1;
nvars = size(fcastdata,2);
errshk = 1;
% identify an oil shock.  Usual Way.

 %code to estimate a  var of the form
% x(t) = a(L)*x(t) + b(L)*y(t) + e_t
% y(t) = c(L)*x(t) + d(L)*y(t) + u_t

[beta1,sigma1,uz1]=estimatevar(fcastdata,nlag,hascon);
betavarz =beta1;
uz = [uz1(:,1) uz1(:,2)];
sigmaz = cov(uz);
a0rec=inv(chol(sigmaz)');

rawimpzmatxfullyfull =  mkimprep(betavarz,a0rec,nlag,errshk,nstep);
impzmatxfullyfull = feval(sortprog,rawimpzmatxfullyfull);
impzout = impzmatxfullyfull;

[beta1,sigma1,uz1]=estimatevar([netchangecensored fcastdata(:,2)],nlag,hascon);
betavarz =beta1;
uz = [uz1(:,1) uz1(:,2)];
sigmaz = cov(uz);
a0rec=inv(chol(sigmaz)');

rawimpzmatxfullyfull =  mkimprep(betavarz,a0rec,nlag,errshk,nstep);
impzmatxfullyfull = feval(sortprog,rawimpzmatxfullyfull);
impznetchange = impzmatxfullyfull;

laststpoint = size(fcastdata,1)-nlag;
nstep = 12;
% 
nlimpz = NaN(nstep+nlag,2,laststpoint,50,4);
nlimpzlev= NaN(nstep+nlag,2,laststpoint,50,4);
shkz = [-2 -1 1 2];
%[nlimpz,levnlimpz] = nlimptvarlevel(fcastdata,nlag,hascon,500,nstep,1,[1 shkz(3)],5,fcastdatalev)
           
netimpzlev = zeros(nstep,2,6,laststpoint);
netimpz = zeros(nstep,2,6,laststpoint);

netimpzlev2 = zeros(nstep,2,6,laststpoint);
netimpz2 = zeros(nstep,2,6,laststpoint);




netimpzlev12v2 = zeros(nstep,2,4,laststpoint);
netimpz12v2 = zeros(nstep,2,4,laststpoint);

ndraws = 20000;
ndraws = 200;
for zx = 1:laststpoint;
     [netimpz12v2(:,:,:,zx), netimpzlev12v2(:,:,:,zx)] = nlimpkv(fcastdata,nlag,hascon,ndraws,nstep,1,[1  -2 -1 1 2 ],zx,fcastdatalevwithzero,12);
end

    
 
  
dotesting =1;
aclock = sum(100*clock)
% s = RandStream.create('mt19937ar','seed',aclock );
% RandStream.setDefaultStream(s);

if dotesting == 1;
    'got here'
    
    nobs = size(fcastdata,1);
    
    zsim = 50;
    ndraws = 100;  %number of simulations is too small.  Change to 10,000.
    
    [simdoutpad,levelsimdatapad] = nlsimkv(fcastdata,nlag,hascon,ndraws,2*nobs,1,1,fcastdatalevwithzero,12);
    simdout = simdoutpad((nobs+1):2*nobs,:,:);
    simdoutlevelwithzero =levelsimdatapad((nobs):2*nobs,:,:);
    
    for zx= ndraws:-1:1;
        tic
        
        for zp = zsim:-1:1;
            [bsnetimpz(:,:,:,zp), bsnetimpzlev(:,:,:,zp)]                    = nlimpkv(simdout(:,:,zx),nlag,hascon,100,nstep,1,[1 -2 -1 1 2],ceil(rand(1)*(nobs-nlag)),simdoutlevelwithzero(:,:,zx),12);
            
        end
        
        svbsnetimpzlong(:,:,:,zx) =mean(bsnetimpz,4);
        svbsnetimpzlevlong(:,:,:,zx) =mean(bsnetimpzlev,4);
        
        
        toc
    end;
    save(['results_' num2str(aclock,'%0.0f')])

    



allsv =  svbsnetimpzlevlong;
nlimpz = netimpzlev12v2;

 wvec2std = zeros(8,1);
% 2 standard deviation shocks. 
for zx= 1:8;
    if zx == 1;
        r = mean(squeeze(nlimpz(1:zx,2,1,:)+nlimpz(1:zx,2,4,:)));
    else
        r = mean(squeeze(nlimpz(1:zx,2,1,:)+nlimpz(1:zx,2,4,:)),2);
    end;
  
    
    
 tmp =  (squeeze(allsv(1:zx,2,1,1:end))+squeeze(allsv(1:zx,2,4,1:end)));
ctmp = cov(tmp');
wvec2std(zx) = r'*inv(ctmp)*r;
 



end
 
  wvec1std = zeros(8,1);
% 1 standard deviation shocks.

for zx= 1:8;
    if zx == 1;
        r = mean(squeeze(nlimpz(1:zx,2,2,:)+nlimpz(1:zx,2,3,:)));
    else
        r = mean(squeeze(nlimpz(1:zx,2,2,:)+nlimpz(1:zx,2,3,:)),2);
    end;
tmp =  (squeeze(allsv(1:zx,2,2,1:end))+squeeze(allsv(1:zx,2,3,1:end)));
ctmp = cov(tmp');
wvec1std(zx) = r'*inv(ctmp)*r;

end


end
 
1-chi2cdf([wvec1std wvec2std ],repmat((1:8)',1,2))
 
